note
	description: "Internal node in a code tree."

class
	INTERNAL_NODE

inherit
	NODE

create
	make

feature {NONE} -- Initialization

	make (l, r: NODE)
			-- Create an internal nodes with children `l' and `r'.			
		require
			l_exists: l /= Void
			r_exists: r /= Void
		do
			left := l
			right := r
			probability := l.probability + r.probability
		ensure
			left_set: left = l
			right_set: right = r
		end

feature -- Access

	left: NODE
			-- Left child.

	right: NODE
			-- Right child.

feature -- Output

	show (indent: STRING)
			-- Pretty-print this subtree.
		do
			print (indent + "(" + ((probability * 100).rounded).out + "%%)")
			io.new_line
			left.show (indent + "  ")
			right.show (indent + "  ")
		end

invariant
	children_exist: left /= Void and right /= Void
	
end
